(*
  DTween

  The MIT License

  Copyright (c) 2011 Lyna, http://twc.xrea.jp/

  Permission is hereby granted, free of charge, to any person obtaining a copy
  of this software and associated documentation files (the "Software"), to deal
  in the Software without restriction, including without limitation the rights
  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  copies of the Software, and to permit persons to whom the Software is
  furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in
  all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  THE SOFTWARE.

  ----------

  XV

    Ver.0.1  11/08/09  *

    Ver.0.2  11/08/12  *TEasing.ElasticEaseOut̃oOC

    Ver.0.3  11/08/14  *TEasingCombine\bhǉ

    Ver.0.4  11/08/15  *Circn֐Combineۂ
                        _Z̗Ooꍇ̂C

    Ver.0.5  11/08/19  *IEasingC^[tF[XV
                       *TEasing.XXXXԂlTEasingFuncIEasingɕύX

    Ver.0.6  11/08/24  *Construct\bhǉ
*)

interface

{$I DTweenCompilerDefines.inc}

uses
  SysUtils;

type
  ETweenEasingException = class(Exception);

  { C[WO֐̃vg^Cvł
    Ɠ`łΖ\bhȊOɊ֐CX^X\bhłOK
    2009Õo[Wł͊֐̂ݎwł܂
    t:
      oߎ
    b:
      vpeB̏l
    c:
      vpeB̕ω
    d:
      p
    ߂l͊{Ib`b+c͈̔͂Ԃ܂ABackElastiĉ悤ɔ͈͊OłOK
    t=d̎͌Ƃb+cԂ悤ɂ܂ }
{$IFDEF USEANONYMOUSMETHOD}
  TEasingFunc = reference to function(const t, b, c, d: Extended): Extended;
{$ELSE}
  TEasingFunc = function(const t, b, c, d: Extended): Extended;
{$ENDIF}

  { C[WO֐C^[tF[X }
  IEasing = interface
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  { eC[WO֐ێNXł }
  TEasing = class
  private
{$IFDEF USECLASSPROPERTY}
  class var
    FLinear: IEasing;
    FSineEaseIn: IEasing;
    FSineEaseInOut: IEasing;
    FSineEaseOut: IEasing;
    FSineEaseOutIn: IEasing;
    FQuadEaseIn: IEasing;
    FQuadEaseInOut: IEasing;
    FQuadEaseOut: IEasing;
    FQuadEaseOutIn: IEasing;
    FCircEaseIn: IEasing;
    FCircEaseInOut: IEasing;
    FCircEaseOut: IEasing;
    FCircEaseOutIn: IEasing;
    FCubicEaseIn: IEasing;
    FCubicEaseInOut: IEasing;
    FCubicEaseOut: IEasing;
    FCubicEaseOutIn: IEasing;
    FExpoEaseIn: IEasing;
    FExpoEaseInOut: IEasing;
    FExpoEaseOut: IEasing;
    FExpoEaseOutIn: IEasing;
    FQuartEaseIn: IEasing;
    FQuartEaseInOut: IEasing;
    FQuartEaseOut: IEasing;
    FQuartEaseOutIn: IEasing;
    FQuintEaseIn: IEasing;
    FQuintEaseInOut: IEasing;
    FQuintEaseOut: IEasing;
    FQuintEaseOutIn: IEasing;
    FBounceEaseIn: IEasing;
    FBounceEaseInOut: IEasing;
    FBounceEaseOut: IEasing;
    FBounceEaseOutIn: IEasing;
{$ENDIF}
  public
    { ̃C[WO֐܂
        Easing1,
        Easing2:
          C[WO֐w肵܂
        Division:
          C[WO֐̕_0.0`1.0͈̔͂Ŏw肵܂ }
    class function Combine(const Easing1, Easing2: IEasing; const Division: Extended = 0.5): IEasing;

    { CӂTEasingFuncbvIEasingC^[tF[XԂ܂ }
    class function Construct(const Easing: TEasingFunc): IEasing;

    { 𐧌䂷C[WO֐QłB
      eɂẮuAS C[WOvƂŃOOԂ񑁂ł
      ͂̕ӎQ
      http://hosted.zeh.com.br/tweener/docs/en-us/misc/transitions.html
      http://mtl.recruit.co.jp/sandbox/terai/blog/tweenTypeViewer/ }

    class function Linear: IEasing;
    class function SineEaseIn: IEasing;
    class function SineEaseInOut: IEasing;
    class function SineEaseOut: IEasing;
    class function SineEaseOutIn: IEasing;
    class function QuadEaseIn: IEasing;
    class function QuadEaseInOut: IEasing;
    class function QuadEaseOut: IEasing;
    class function QuadEaseOutIn: IEasing;
    class function CircEaseIn: IEasing;
    class function CircEaseInOut: IEasing;
    class function CircEaseOut: IEasing;
    class function CircEaseOutIn: IEasing;
    class function CubicEaseIn: IEasing;
    class function CubicEaseInOut: IEasing;
    class function CubicEaseOut: IEasing;
    class function CubicEaseOutIn: IEasing;
    class function ExpoEaseIn: IEasing;
    class function ExpoEaseInOut: IEasing;
    class function ExpoEaseOut: IEasing;
    class function ExpoEaseOutIn: IEasing;
    class function QuartEaseIn: IEasing;
    class function QuartEaseInOut: IEasing;
    class function QuartEaseOut: IEasing;
    class function QuartEaseOutIn: IEasing;
    class function QuintEaseIn: IEasing;
    class function QuintEaseInOut: IEasing;
    class function QuintEaseOut: IEasing;
    class function QuintEaseOutIn: IEasing;
    class function BackEaseIn(const s:Extended = 1.70158): IEasing;
    class function BackEaseInOut(const s:Extended = 1.70158): IEasing;
    class function BackEaseOut(const s:Extended = 1.70158): IEasing;
    class function BackEaseOutIn(const s:Extended = 1.70158): IEasing;
    class function BounceEaseIn: IEasing;
    class function BounceEaseInOut: IEasing;
    class function BounceEaseOut: IEasing;
    class function BounceEaseOutIn: IEasing;
    class function ElasticEaseIn(const a: Extended = 0; const p: Extended = 0): IEasing;
    class function ElasticEaseInOut(const a: Extended = 0; const p: Extended = 0): IEasing;
    class function ElasticEaseOut(const a: Extended = 0; const p: Extended = 0): IEasing;
    class function ElasticEaseOutIn(const a: Extended = 0; const p: Extended = 0): IEasing;
  end;

implementation

uses Math;

{$IFNDEF USECLASSPROPERTY}
var
  FLinear: IEasing;
  FSineEaseIn: IEasing;
  FSineEaseInOut: IEasing;
  FSineEaseOut: IEasing;
  FSineEaseOutIn: IEasing;
  FQuadEaseIn: IEasing;
  FQuadEaseInOut: IEasing;
  FQuadEaseOut: IEasing;
  FQuadEaseOutIn: IEasing;
  FCircEaseIn: IEasing;
  FCircEaseInOut: IEasing;
  FCircEaseOut: IEasing;
  FCircEaseOutIn: IEasing;
  FCubicEaseIn: IEasing;
  FCubicEaseInOut: IEasing;
  FCubicEaseOut: IEasing;
  FCubicEaseOutIn: IEasing;
  FExpoEaseIn: IEasing;
  FExpoEaseInOut: IEasing;
  FExpoEaseOut: IEasing;
  FExpoEaseOutIn: IEasing;
  FQuartEaseIn: IEasing;
  FQuartEaseInOut: IEasing;
  FQuartEaseOut: IEasing;
  FQuartEaseOutIn: IEasing;
  FQuintEaseIn: IEasing;
  FQuintEaseInOut: IEasing;
  FQuintEaseOut: IEasing;
  FQuintEaseOutIn: IEasing;
  FBounceEaseIn: IEasing;
  FBounceEaseInOut: IEasing;
  FBounceEaseOut: IEasing;
  FBounceEaseOutIn: IEasing;
{$ENDIF}

type
  TEasingCombine = class(TInterfacedObject, IEasing)
  private
    FEasing1: IEasing;
    FEasing2: IEasing;
    FDivision: Extended;
  public
    constructor Create(const Easing1, Easing2: IEasing; const Division: Extended);
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingConstruct = class(TInterfacedObject, IEasing)
  private
    FEasing: TEasingFunc;
  public
    constructor Create(const Easing: TEasingFunc);
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingLinear = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingSineEaseIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingSineEaseInOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingSineEaseOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingSineEaseOutIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingQuadEaseIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingQuadEaseInOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingQuadEaseOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingQuadEaseOutIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingCircEaseIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingCircEaseInOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingCircEaseOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingCircEaseOutIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingCubicEaseIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingCubicEaseInOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingCubicEaseOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingCubicEaseOutIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingExpoEaseIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingExpoEaseInOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingExpoEaseOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingExpoEaseOutIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingQuartEaseIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingQuartEaseInOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingQuartEaseOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingQuartEaseOutIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingQuintEaseIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingQuintEaseInOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingQuintEaseOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingQuintEaseOutIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingBack = class(TInterfacedObject)
  protected
    FS: Extended;
  public
    constructor Create(const s: Extended);
  end;

  TEasingBackEaseIn = class(TEasingBack, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingBackEaseInOut = class(TEasingBack, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingBackEaseOut = class(TEasingBack, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingBackEaseOutIn = class(TEasingBack, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingBounceEaseIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingBounceEaseInOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingBounceEaseOut = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingBounceEaseOutIn = class(TInterfacedObject, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingElastic = class(TInterfacedObject)
  protected
    FA, FP: Extended;
  public
    constructor Create(const a, p: Extended);
  end;

  TEasingElasticEaseIn = class(TEasingElastic, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingElasticEaseInOut = class(TEasingElastic, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingElasticEaseOut = class(TEasingElastic, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

  TEasingElasticEaseOutIn = class(TEasingElastic, IEasing)
  public
    function Calculate(const t, b, c, d: Extended): Extended;
  end;

{ TEasingCombine }

constructor TEasingCombine.Create(const Easing1, Easing2: IEasing;
  const Division: Extended);
begin
  FEasing1 := Easing1;
  FEasing2 := Easing2;
  FDivision := Division;

  if not Assigned(FEasing1) then
    raise ETweenEasingException.Create('Easing1nilł');

  if not Assigned(FEasing2) then
    raise ETweenEasingException.Create('Easing2nilł');

  if (FDivision < 0) or (FDivision > 1) then
    raise ETweenEasingException.CreateFmt('Division0`1͈͓̔Ŏw肵ĉ (Division = %.8f)', [FDivision]);
end;

function TEasingCombine.Calculate(const t, b, c, d: Extended): Extended;
var
  _t: Extended;
  _b: Extended;
  _c: Extended;
  _d: Extended;
begin
  _d := Trunc(d * FDivision);
  if t <= _d then
  begin
    _c := c * FDivision;
    Result := FEasing1.Calculate(t, b, _c, _d);
  end
  else begin
    _t := t - _d;
    _b := b + c * FDivision;
    _c := c * (1 - FDivision);
    _d := d - _d;
    Result := FEasing2.Calculate(_t, _b, _c, _d);
  end;
end;

{ TEasingConstruct }

constructor TEasingConstruct.Create(const Easing: TEasingFunc);
begin
  FEasing := Easing;

  if not Assigned(FEasing) then
    raise ETweenEasingException.Create('Easingnilł');
end;

function TEasingConstruct.Calculate(const t, b, c, d: Extended): Extended;
begin
  Result := FEasing(t, b, c, d);
end;

{ TEasingLinear }

function TEasingLinear.Calculate(const t, b, c, d: Extended): Extended;
begin
  Result := c * t / d + b;
end;

{ TEasingSineEaseIn }

function TEasingSineEaseIn.Calculate(const t, b, c, d: Extended): Extended;
begin
  Result := -c * Cos(t / d * (Pi / 2)) + c + b;
end;

{ TEasingSineEaseInOut }

function TEasingSineEaseInOut.Calculate(const t, b, c, d: Extended): Extended;
begin
  Result := -c / 2 * (Cos(Pi * t / d) - 1) + b;
end;

{ TEasingSineEaseOut }

function TEasingSineEaseOut.Calculate(const t, b, c, d: Extended): Extended;
begin
  Result := c * Sin(t / d * (Pi / 2)) + b;
end;

{ TEasingSineEaseOutIn }

function TEasingSineEaseOutIn.Calculate(const t, b, c, d: Extended): Extended;
begin
  if t < d / 2 then
    Result := (c / 2) * Sin((t * 2) / d * (Pi / 2)) + b
  else
    Result := -(c / 2) * Cos((t * 2 - d) / d * (Pi / 2)) + (c / 2) + (b + c / 2);
end;

{ TEasingQuadEaseIn }

function TEasingQuadEaseIn.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d;
  Result := c * t1 * t1 + b;
end;

{ TEasingQuadEaseInOut }

function TEasingQuadEaseInOut.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / (d / 2);
  if t1 < 1 then
    Result := c / 2 * t1 * t1 + b
  else
  begin
    t1 := t1 - 1;
    Result := -c / 2 * (t1 * (t1 - 2) - 1) + b;
  end
end;

{ TEasingQuadEaseOut }

function TEasingQuadEaseOut.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d;
  Result := -c * t1 * (t1 - 2) + b;
end;

{ TEasingQuadEaseOutIn }

function TEasingQuadEaseOutIn.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t < d / 2 then
  begin
    t1 := t * 2 / d;
    Result := -(c / 2) * t1 * (t1 - 2) + b;
  end
  else begin
    t1 := (t * 2 - d) / d;
    Result := (c / 2) * t1 * t1 + (b + c / 2);
  end;
end;

{ TEasingCircEaseIn }

function TEasingCircEaseIn.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d;
  Result := -c * (Sqrt(1 - t1 * t1) - 1) + b;
end;

{ TEasingCircEaseInOut }

function TEasingCircEaseInOut.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / (d / 2);
  if t1 < 1 then
    Result := -c / 2 * (Sqrt(1 - t1 * t1) - 1) + b
  else
  begin
    t1 := t1 - 2;
    Result := c / 2 * (Sqrt(1 - t1 * t1) + 1) + b;
  end;
end;

{ TEasingCircEaseOut }

function TEasingCircEaseOut.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d - 1;
  Result := c * Sqrt(1 - t1 * t1) + b;
end;

{ TEasingCircEaseOutIn }

function TEasingCircEaseOutIn.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t < d / 2 then
  begin
    t1 := (t * 2) / d - 1;
    Result := (c / 2) * Sqrt(1 - t1 * t1) + b
  end
  else begin
    t1 := (t * 2 - d) / d;
    Result := -(c / 2) * (Sqrt(1 - t1 * t1) - 1) + (b + c / 2);
  end;
end;

{ TEasingCubicEaseIn }

function TEasingCubicEaseIn.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d;
  Result := c * t1 * t1 * t1 + b;
end;

{ TEasingCubicEaseInOut }

function TEasingCubicEaseInOut.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / (d / 2);
  if t1 < 1 then
    Result := c / 2 * t1 * t1 * t1 + b
  else
  begin
    t1 := t1 - 2;
    Result := c / 2 * (t1 * t1 * t1 + 2) + b;
  end;
end;

{ TEasingCubicEaseOut }

function TEasingCubicEaseOut.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d - 1;
  Result := c * (t1 * t1 * t1 + 1) + b;
end;

{ TEasingCubicEaseOutIn }

function TEasingCubicEaseOutIn.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t < d / 2 then
  begin
    t1 := t * 2 / d - 1;
    Result := c / 2 * (t1 * t1 * t1 + 1) + b;
  end
  else begin
    t1 := (t * 2 - d) / d;
    Result := c / 2 * t1 * t1 * t1 + b + c / 2;
  end;
end;

{ TEasingExpoEaseIn }

function TEasingExpoEaseIn.Calculate(const t, b, c, d: Extended): Extended;
begin
  if t = 0 then
    Result := b
  else
    Result := c * Power(2, 10 * (t / d - 1)) + b;
end;

{ TEasingExpoEaseInOut }

function TEasingExpoEaseInOut.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t = 0 then
  begin
    Result := b;
    Exit;
  end;
  if t = d then
  begin
    Result := b + c;
    Exit;
  end;
  t1 := t / (d / 2);
  if t1 < 1 then
  begin
    Result := c / 2 * Power(2, 10 * (t1 - 1)) + b;
    Exit;
  end;
  t1 := t1 - 1;
  Result := c / 2 * (2 - Power(2, -10 * t1)) + b;
end;

{ TEasingExpoEaseOut }

function TEasingExpoEaseOut.Calculate(const t, b, c, d: Extended): Extended;
begin
  if t = d then
    Result := b + c
  else
    Result := c * (1 - Power(2, -10 * t / d)) + b;
end;

{ TEasingExpoEaseOutIn }

function TEasingExpoEaseOutIn.Calculate(const t, b, c, d: Extended): Extended;
begin
  if t < d / 2 then
  begin
    if t * 2 = d then
      Result := b + c / 2
    else
      Result := c / 2 * (1 - Power(2, -10 * t * 2 / d)) + b;
  end
  else begin
    if t * 2 - d = 0 then
      Result := b + c / 2
    else
      Result := c / 2 * Power(2, 10 * ((t * 2 - d) / d - 1)) + b + c / 2;
  end;
end;

{ TEasingQuartEaseIn }

function TEasingQuartEaseIn.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d;
  Result := c * t1 * t1 * t1 * t1 + b;
end;

{ TEasingQuartEaseInOut }

function TEasingQuartEaseInOut.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / (d / 2);
  if t1 < 1 then
    Result := c / 2 * t1 * t1 * t1 * t1 + b
  else
  begin
    t1 := t1 - 2;
    Result := -c / 2 * (t1 * t1 * t1 * t1 - 2) + b;
  end;
end;

{ TEasingQuartEaseOut }

function TEasingQuartEaseOut.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d - 1;
  Result := -c * (t1 * t1 * t1 * t1 - 1) + b;
end;

{ TEasingQuartEaseOutIn }

function TEasingQuartEaseOutIn.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t < d / 2 then
  begin
    t1 := (t * 2) / d - 1;
    Result := -(c / 2) * (t1 * t1 * t1 * t1 - 1) + b;
  end
  else begin
    t1 := (t * 2 - d) / d;
    Result := (c / 2) * t1 * t1 * t1 * t1 + (b + c / 2);
  end;
end;

{ TEasingQuintEaseIn }

function TEasingQuintEaseIn.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d;
  Result := c * t1 * t1 * t1 * t1 * t1 + b;
end;

{ TEasingQuintEaseInOut }

function TEasingQuintEaseInOut.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / (d / 2);
  if t1 < 1 then
    Result := c / 2 * t1 * t1 * t1 * t1 * t1 + b
  else begin
    t1 := t1 - 2;
    Result := c / 2 * (t1 * t1 * t1 * t1 * t1 + 2) + b;
  end;
end;

{ TEasingQuintEaseOut }

function TEasingQuintEaseOut.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d - 1;
  Result := c * (t1 * t1 * t1 * t1 * t1 + 1) + b;
end;

{ TEasingQuintEaseOutIn }

function TEasingQuintEaseOutIn.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t < d / 2 then
  begin
    t1 := (t * 2) / d - 1;
    Result := (c / 2) * (t1 * t1 * t1 * t1 * t1 + 1) + b;
  end
  else begin
    t1 := (t * 2 - d) / d;
    Result := (c / 2) * t1 * t1 * t1 * t1 * t1 + (b + c / 2);
  end;
end;

constructor TEasingBack.Create(const s: Extended);
begin
  FS := s;
end;

{ TEasingBackEaseIn }

function TEasingBackEaseIn.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d;
  Result := c * t1 * t1 * ((FS + 1) * t1 - FS) + b;
end;

{ TEasingBackEaseInOut }

function TEasingBackEaseInOut.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / (d / 2);
  if t1 < 1 then
    Result := c / 2 * (t1 * t1 * (((FS * 1.525) + 1) * t1 - FS * 1.525)) + b
  else begin
    t1 := t1 - 2;
    Result := c / 2 * (t1 * t1 * (((FS * 1.525) + 1) * t1 + FS * 1.525) + 2) + b;
  end;
end;

{ TEasingBackEaseOut }

function TEasingBackEaseOut.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d - 1;
  Result := c * (t1 * t1 * ((FS + 1) * t1 + FS) + 1) + b;
end;

{ TEasingBackEaseOutIn }

function TEasingBackEaseOutIn.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t < d / 2 then
  begin
    t1 := (t * 2) / d - 1;
    Result := (c / 2) * (t1 * t1 * ((FS + 1) * t1 + FS) + 1) + b;
  end
  else begin
    t1 := (t * 2 - d) / d;
    Result := (c / 2) * t1 * t1 * ((FS + 1) * t1 - FS) + (b + c / 2);
  end;
end;

{ TEasingBounceEaseIn }

function TEasingBounceEaseIn.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := (d - t) / d;
  if t1 < (1 / 2.75) then
  begin
    Result := c - (c * (7.5625 * t1 * t1)) + b;
    Exit;
  end;
  if t1 < (2 / 2.75) then
  begin
    t1 := t1 - 1.5 / 2.75;
    Result := c - (c * (7.5625 * t1 * t1 + 0.75)) + b;
    Exit;
  end;
  if t1 < 2.5 / 2.75 then
  begin
    t1 := t1 - 2.25 / 2.75;
    Result := c - (c * (7.5625 * t1 * t1 + 0.9375)) + b;
    Exit;
  end;
  t1 := t1 - 2.625 / 2.75;
  Result := c - (c * (7.5625 * t1 * t1 + 0.984375)) + b;
end;

{ TEasingBounceEaseInOut }

function TEasingBounceEaseInOut.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t < d / 2 then
  begin
    t1 := (d - t * 2) / d;
    if t1 < 1 / 2.75 then
    begin
      Result := (c - (c * (7.5625 * t1 * t1))) * 0.5 + b;
      Exit;
    end;
    if t1 < 2 / 2.75 then
    begin
      t1 := t1 - 1.5 / 2.75;
      Result := (c - (c * (7.5625 * t1 * t1 + 0.75))) * 0.5 + b;
      Exit;
    end;
    if t1 < 2.5 / 2.75 then
    begin
      t1 := t1 - 2.25 / 2.75;
      Result := (c - (c * (7.5625 * t1 * t1 + 0.9375))) * 0.5 + b;
      Exit;
    end;
    t1 := t1 - 2.625 / 2.75;
    Result := (c - (c * (7.5625 * t1 * t1 + 0.984375))) * 0.5 + b;
  end
  else begin
    t1 := (t * 2 - d) / d;
    if t1 < 1 / 2.75 then
    begin
      Result := (c * (7.5625 * t1 * t1)) * 0.5 + c * 0.5 + b;
      Exit;
    end;
    if t1 < 2 / 2.75 then
    begin
      t1 := t1 - 1.5 / 2.75;
      Result := (c * (7.5625 * t1 * t1 + 0.75)) * 0.5 + c * 0.5 + b;
      Exit;
    end;
    if t1 < 2.5 / 2.75 then
    begin
      t1 := t1 - 2.25 / 2.75;
      Result := (c * (7.5625 * t1 * t1 + 0.9375)) * 0.5 + c * 0.5 + b;
      Exit;
    end;
    t1 := t1 - 2.625 / 2.75;
    Result := (c * (7.5625 * t1 * t1 + 0.984375)) * 0.5 + c * 0.5 + b;
  end;
end;

{ TEasingBounceEaseOut }

function TEasingBounceEaseOut.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  t1 := t / d;
  if t1 < 1 / 2.75 then
  begin
    Result := c * (7.5625 * t1 * t1) + b;
    Exit;
  end;
  if t1 < 2 / 2.75 then
  begin
    t1 := t1 - 1.5 / 2.75;
    Result := c * (7.5625 * t1 * t1 + 0.75) + b;
    Exit;
  end;
  if t1 < 2.5 / 2.75 then
  begin
    t1 := t1 - 2.25 / 2.75;
    Result := c * (7.5625 * t1 * t1 + 0.9375) + b;
    Exit;
  end;
  t1 := t1 - 2.625 / 2.75;
  Result := c * (7.5625 * t1 * t1 + 0.984375) + b;
end;

{ TEasingBounceEaseOutIn }

function TEasingBounceEaseOutIn.Calculate(const t, b, c, d: Extended): Extended;
var
  t1: Extended;
begin
  if t < d / 2 then
  begin
    t1 := (t * 2) / d;
    if t1 < 1 / 2.75 then
    begin
      Result := (c / 2) * (7.5625 * t1 * t1) + b;
      Exit;
    end;
    if t1 < 2 / 2.75 then
    begin
      t1 := t1 - 1.5 / 2.75;
      Result := (c / 2) * (7.5625 * t1 * t1 + 0.75) + b;
      Exit;
    end;
    if t1 < 2.5 / 2.75 then
    begin
      t1 := t1 - 2.25 / 2.75;
      Result := (c / 2) * (7.5625 * t1 * t1 + 0.9375) + b;
      Exit;
    end;
    t1 := t1 - 2.625 / 2.75;
    Result := (c / 2) * (7.5625 * t1 * t1 + 0.984375) + b;
  end
  else begin
    t1 := (d - (t * 2 - d)) / d;
    if t1 < 1 / 2.75 then
    begin
      Result := (c / 2) - ((c / 2) * (7.5625 * t1 * t1)) + (b + c / 2);
      Exit;
    end;
    if t1 < 2 / 2.75 then
    begin
      t1 := t1 - 1.5 / 2.75;
      Result := (c / 2) - ((c / 2) * (7.5625 * t1 * t1 + 0.75)) + (b + c / 2);
      Exit;
    end;
    if t1 < 2.5 / 2.75 then
    begin
      t1 := t1 - 2.25 / 2.75;
      Result := (c / 2) - ((c / 2) * (7.5625 * t1 * t1 + 0.9375)) + (b + c / 2);
      Exit;
    end;
    t1 := t1 - 2.625 / 2.75;
    Result := (c / 2) - ((c / 2) * (7.5625 * t1 * t1 + 0.984375)) + (b + c / 2);
  end;
end;

{ TEasingElastic }

constructor TEasingElastic.Create(const a, p: Extended);
begin
  FA := a;
  FP := p;
end;

{ TEasingElasticEaseIn }

function TEasingElasticEaseIn.Calculate(const t, b, c, d: Extended): Extended;
var
  _a: Extended;
  _p: Extended;
  s: Extended;
  t1: Extended;
begin
  if t = 0 then
  begin
    Result := b;
    Exit;
  end;
  t1 := t / d;
  if t1 = 1 then
  begin
    Result := b + c;
    Exit;
  end;
  _a := FA;
  _p := FP;
  if _p = 0 then
  begin
    _p := d * 0.3;
  end;
  if (_a = 0) or (_a < Abs(c)) then
  begin
    _a := c;
    s := _p / 4;
  end
  else begin
    s := _p / (2 * Pi) * ArcSin(c / _a);
  end;
  t1 := t1 - 1;
  Result := -(_a * Power(2, 10 * t1) * Sin((t1 * d - s) * (2 * Pi) / _p)) + b;
end;

{ TEasingElasticEaseInOut }

function TEasingElasticEaseInOut.Calculate(const t, b, c, d: Extended): Extended;
var
  _a: Extended;
  _p: Extended;
  s: Extended;
  t1: Extended;
begin
  if t = 0 then
  begin
    Result := b;
    Exit;
  end;
  t1 := t / (d / 2);
  if t1 = 2 then
  begin
    Result := b + c;
    Exit;
  end;
  _a := FA;
  _p := FP;
  if _p = 0 then
  begin
    _p := d * (0.3 * 1.5);
  end;
  if (_a = 0) or (_a < Abs(c)) then
  begin
    _a := c;
    s := _p / 4;
  end
  else begin
    s := _p / (2 * Pi) * ArcSin(c / _a);
  end;
  t1 := t1 - 1;
  if t1 < 0 then
    Result := -0.5 * (_a * Power(2, 10 * t1) * Sin((t1 * d - s) * (2 * Pi) / _p)) + b
  else
    Result := _a * Power(2, -10 * t1) * Sin((t1 * d - s) * (2 * Pi) / _p) * 0.5 + c + b;
end;

{ TEasingElasticEaseOut }

function TEasingElasticEaseOut.Calculate(const t, b, c, d: Extended): Extended;
var
  _a: Extended;
  _p: Extended;
  s: Extended;
  t1: Extended;
begin
  if t = 0 then
  begin
    Result := b;
    Exit;
  end;
  t1 := t / d;
  if t1 = 1 then
  begin
    Result := b + c;
    Exit;
  end;
  _a := FA;
  _p := FP;
  if _p = 0 then
  begin
    _p := d * 0.3;
  end;
  if (_a = 0) or (_a < Abs(c)) then
  begin
    _a := c;
    s := _p / 4;
  end
  else begin
    s := _p / (2 * Pi) * ArcSin(c / _a);
  end;
  Result := _a * Power(2, -10 * t1) * Sin((t1 * d - s) * (2 * Pi) / _p) + c + b;
end;

{ TEasingElasticEaseOutIn }

function TEasingElasticEaseOutIn.Calculate(const t, b, c, d: Extended): Extended;
var
  _a: Extended;
  _p: Extended;
  s: Extended;
  c1: Extended;
  t1: Extended;
begin
  c1 := c / 2;
  _a := FA;
  _p := FP;
  if t < d / 2 then
  begin
    t1 := t * 2;
    if t1 = 0 then
    begin
      Result := b;
      Exit;
    end;
    t1 := t1 / d;
    if t1 = 1 then
    begin
      Result := b + c1;
      Exit;
    end;
    if _p = 0 then
    begin
      _p := d * 0.3;
    end;
    if (_a = 0) or (_a < Abs(c1)) then
    begin
      _a := c1;
      s := _p / 4;
    end
    else begin
      s := _p / (2 * Pi) * ArcSin(c1 / _a);
    end;
    Result := _a * Power(2, -10 * t1) * Sin((t1 * d - s) * (2 * Pi) / _p) + c1 + b;
  end
  else begin
    t1 := t * 2 - d;
    if t1 = 0 then
    begin
      Result := b + c1;
      Exit;
    end;
    t1 := t1 / d;
    if t1 = 1 then
    begin
      Result := b + c1 + c1;
      Exit;
    end;
    if _p = 0 then
    begin
      _p := d * 0.3;
    end;
    if (_a = 0) or (_a < Abs(c1)) then
    begin
      _a := c1;
      s := _p / 4;
    end
    else begin
      s := _p / (2 * Pi) * ArcSin(c1 / _a);
    end;
    t1 := t1 - 1;
    Result := -(_a * Power(2, 10 * t1) * Sin((t1 * d - s) * (2 * Pi) / _p)) + (b + c1);
  end;
end;

{ TEasing }

class function TEasing.Combine(const Easing1, Easing2: IEasing; const Division: Extended): IEasing;
begin
  Result := TEasingCombine.Create(Easing1, Easing2, Division);
end;

class function TEasing.Construct(const Easing: TEasingFunc): IEasing;
begin
  Result := TEasingConstruct.Create(Easing);
end;

class function TEasing.Linear: IEasing;
begin
  if not Assigned(FLinear) then FLinear := TEasingLinear.Create;
  Result := FLinear;
end;

class function TEasing.SineEaseIn: IEasing;
begin
  if not Assigned(FSineEaseIn) then FSineEaseIn := TEasingSineEaseIn.Create;
  Result := FSineEaseIn;
end;

class function TEasing.SineEaseInOut: IEasing;
begin
  if not Assigned(FSineEaseInOut) then FSineEaseInOut := TEasingSineEaseInOut.Create;
  Result := FSineEaseInOut;
end;

class function TEasing.SineEaseOut: IEasing;
begin
  if not Assigned(FSineEaseOut) then FSineEaseOut := TEasingSineEaseOut.Create;
  Result := FSineEaseOut;
end;

class function TEasing.SineEaseOutIn: IEasing;
begin
  if not Assigned(FSineEaseOutIn) then FSineEaseOutIn := TEasingSineEaseOutIn.Create;
  Result := FSineEaseOutIn;
end;

class function TEasing.QuadEaseIn: IEasing;
begin
  if not Assigned(FQuadEaseIn) then FQuadEaseIn := TEasingQuadEaseIn.Create;
  Result := FQuadEaseIn;
end;

class function TEasing.QuadEaseInOut: IEasing;
begin
  if not Assigned(FQuadEaseInOut) then FQuadEaseInOut := TEasingQuadEaseInOut.Create;
  Result := FQuadEaseInOut;
end;

class function TEasing.QuadEaseOut: IEasing;
begin
  if not Assigned(FQuadEaseOut) then FQuadEaseOut := TEasingQuadEaseOut.Create;
  Result := FQuadEaseOut;
end;

class function TEasing.QuadEaseOutIn: IEasing;
begin
  if not Assigned(FQuadEaseOutIn) then FQuadEaseOutIn := TEasingQuadEaseOutIn.Create;
  Result := FQuadEaseOutIn;
end;

class function TEasing.CircEaseIn: IEasing;
begin
  if not Assigned(FCircEaseIn) then FCircEaseIn := TEasingCircEaseIn.Create;
  Result := FCircEaseIn;
end;

class function TEasing.CircEaseInOut: IEasing;
begin
  if not Assigned(FCircEaseInOut) then FCircEaseInOut := TEasingCircEaseInOut.Create;
  Result := FCircEaseInOut;
end;

class function TEasing.CircEaseOut: IEasing;
begin
  if not Assigned(FCircEaseOut) then FCircEaseOut := TEasingCircEaseOut.Create;
  Result := FCircEaseOut;
end;

class function TEasing.CircEaseOutIn: IEasing;
begin
  if not Assigned(FCircEaseOutIn) then FCircEaseOutIn := TEasingCircEaseOutIn.Create;
  Result := FCircEaseOutIn;
end;

class function TEasing.CubicEaseIn: IEasing;
begin
  if not Assigned(FCubicEaseIn) then FCubicEaseIn := TEasingCubicEaseIn.Create;
  Result := FCubicEaseIn;
end;

class function TEasing.CubicEaseInOut: IEasing;
begin
  if not Assigned(FCubicEaseInOut) then FCubicEaseInOut := TEasingCubicEaseInOut.Create;
  Result := FCubicEaseInOut;
end;

class function TEasing.CubicEaseOut: IEasing;
begin
  if not Assigned(FCubicEaseOut) then FCubicEaseOut := TEasingCubicEaseOut.Create;
  Result := FCubicEaseOut;
end;

class function TEasing.CubicEaseOutIn: IEasing;
begin
  if not Assigned(FCubicEaseOutIn) then FCubicEaseOutIn := TEasingCubicEaseOutIn.Create;
  Result := FCubicEaseOutIn;
end;

class function TEasing.ExpoEaseIn: IEasing;
begin
  if not Assigned(FExpoEaseIn) then FExpoEaseIn := TEasingExpoEaseIn.Create;
  Result := FExpoEaseIn;
end;

class function TEasing.ExpoEaseInOut: IEasing;
begin
  if not Assigned(FExpoEaseInOut) then FExpoEaseInOut := TEasingExpoEaseInOut.Create;
  Result := FExpoEaseInOut;
end;

class function TEasing.ExpoEaseOut: IEasing;
begin
  if not Assigned(FExpoEaseOut) then FExpoEaseOut := TEasingExpoEaseOut.Create;
  Result := FExpoEaseOut;
end;

class function TEasing.ExpoEaseOutIn: IEasing;
begin
  if not Assigned(FExpoEaseOutIn) then FExpoEaseOutIn := TEasingExpoEaseOutIn.Create;
  Result := FExpoEaseOutIn;
end;

class function TEasing.QuartEaseIn: IEasing;
begin
  if not Assigned(FQuartEaseIn) then FQuartEaseIn := TEasingQuartEaseIn.Create;
  Result := FQuartEaseIn;
end;

class function TEasing.QuartEaseInOut: IEasing;
begin
  if not Assigned(FQuartEaseInOut) then FQuartEaseInOut := TEasingQuartEaseInOut.Create;
  Result := FQuartEaseInOut;
end;

class function TEasing.QuartEaseOut: IEasing;
begin
  if not Assigned(FQuartEaseOut) then FQuartEaseOut := TEasingQuartEaseOut.Create;
  Result := FQuartEaseOut;
end;

class function TEasing.QuartEaseOutIn: IEasing;
begin
  if not Assigned(FQuartEaseOutIn) then FQuartEaseOutIn := TEasingQuartEaseOutIn.Create;
  Result := FQuartEaseOutIn;
end;

class function TEasing.QuintEaseIn: IEasing;
begin
  if not Assigned(FQuintEaseIn) then FQuintEaseIn := TEasingQuintEaseIn.Create;
  Result := FQuintEaseIn;
end;

class function TEasing.QuintEaseInOut: IEasing;
begin
  if not Assigned(FQuintEaseInOut) then FQuintEaseInOut := TEasingQuintEaseInOut.Create;
  Result := FQuintEaseInOut;
end;

class function TEasing.QuintEaseOut: IEasing;
begin
  if not Assigned(FQuintEaseOut) then FQuintEaseOut := TEasingQuintEaseOut.Create;
  Result := FQuintEaseOut;
end;

class function TEasing.QuintEaseOutIn: IEasing;
begin
  if not Assigned(FQuintEaseOutIn) then FQuintEaseOutIn := TEasingQuintEaseOutIn.Create;
  Result := FQuintEaseOutIn;
end;

class function TEasing.BackEaseIn(const s:Extended = 1.70158): IEasing;
begin
  Result := TEasingBackEaseIn.Create(s);
end;

class function TEasing.BackEaseInOut(const s:Extended = 1.70158): IEasing;
begin
  Result := TEasingBackEaseInOut.Create(s);
end;

class function TEasing.BackEaseOut(const s:Extended = 1.70158): IEasing;
begin
  Result := TEasingBackEaseOut.Create(s);
end;

class function TEasing.BackEaseOutIn(const s:Extended = 1.70158): IEasing;
begin
  Result := TEasingBackEaseOutIn.Create(s);
end;

class function TEasing.BounceEaseIn: IEasing;
begin
  if not Assigned(FBounceEaseIn) then FBounceEaseIn := TEasingBounceEaseIn.Create;
  Result := FBounceEaseIn;
end;

class function TEasing.BounceEaseInOut: IEasing;
begin
  if not Assigned(FBounceEaseInOut) then FBounceEaseInOut := TEasingBounceEaseInOut.Create;
  Result := FBounceEaseInOut;
end;

class function TEasing.BounceEaseOut: IEasing;
begin
  if not Assigned(FBounceEaseOut) then FBounceEaseOut := TEasingBounceEaseOut.Create;
  Result := FBounceEaseOut;
end;

class function TEasing.BounceEaseOutIn: IEasing;
begin
  if not Assigned(FBounceEaseOutIn) then FBounceEaseOutIn := TEasingBounceEaseOutIn.Create;
  Result := FBounceEaseOutIn;
end;

class function TEasing.ElasticEaseIn(const a: Extended = 0; const p: Extended = 0): IEasing;
begin
  Result := TEasingElasticEaseIn.Create(a, p);
end;

class function TEasing.ElasticEaseInOut(const a: Extended = 0; const p: Extended = 0): IEasing;
begin
  Result := TEasingElasticEaseInOut.Create(a, p);
end;

class function TEasing.ElasticEaseOut(const a: Extended = 0; const p: Extended = 0): IEasing;
begin
  Result := TEasingElasticEaseOut.Create(a, p);
end;

class function TEasing.ElasticEaseOutIn(const a: Extended = 0; const p: Extended = 0): IEasing;
begin
  Result := TEasingElasticEaseOutIn.Create(a, p);
end;

end.
